--                           [[  m19lib   ]]
--                           [[  by Mic   ]]
--                           [[  ver 1.2  ]]

include asm.e
include ports.e
include machine.e

without warning

global constant no_fading=-666
global constant no_delay=-667

sequence clip_box_coords
clip_box_coords={{0,0},{319,199}}
sequence outRegs,inRegs
outRegs={0,0,0,0,0,0,0,0,0,0}
inRegs=outRegs


global procedure set_vga()
outRegs={0,0,0,0,0,0,0,0,0,0}
outRegs[REG_AX]=#13
inRegs=dos_interrupt(#10,outRegs)
end procedure

global procedure restore_graphics()
if machine_func(5,-1) then end if
end procedure

global procedure set_clip_box(sequence tha_clip_coords)
if length(tha_clip_coords)=2 then
if length(tha_clip_coords[1])=2 then
if length(tha_clip_coords[1])=2 then
if tha_clip_coords[1][1]<tha_clip_coords[2][1] then
if tha_clip_coords[1][2]<tha_clip_coords[2][2] then
if tha_clip_coords[1][1]>=0 then
if tha_clip_coords[1][1]<318 then
if tha_clip_coords[1][2]>=0 then
if tha_clip_coords[1][2]<198 then
if tha_clip_coords[2][1]<=319 then
if tha_clip_coords[2][2]<=199 then
clip_box_coords=tha_clip_coords
end if
end if
end if
end if
end if
end if
end if
end if
end if
end if
end if
end procedure


function abs(integer num1)
if (num1<0) then
num1=-num1
end if
return num1
end function

global function diff(integer num1,integer num2)
integer retNum
if (num1>=0) and (num2>=0) then
retNum=abs(num1-num2)
end if
if (num1>=0) and (num2<0) then
retNum=num1+abs(num2)
end if
if (num1<0) and (num2>=0) then
retNum=abs(num1)+num2
end if
if (num1<0) and (num2<0) then
retNum=abs(num1-num2)
end if
return retNum
end function

constant wait_vrt_code=get_asm(
"pusha cld "&
"mov edx,986 "&
"waitLbl1: "&
"in ax,dx "&
"and al,8 "&
"jnz waitLbl1 "&
"waitLbl2: "&
"in ax,dx "&
"and al,8 "&
"jz waitLbl2 "&
"popa ret")

global procedure wait_vrt()
call(wait_vrt_code)
end procedure

constant short_wait_vrt_code=get_asm(
"pusha cld "&
"mov edx,986 "&
"shortwaitLbl1: "&
"in ax,dx "&
"and al,1 "&
"jnz shortwaitLbl1 "&
"shortwaitLbl2: "&
"in ax,dx "&
"and al,1 "&
"jz shortwaitLbl2 "&
"popa ret")

global procedure short_wait_vrt()
call(short_wait_vrt_code)
end procedure


--unfinished routine...
global procedure asm_txt(sequence txt_coords,sequence txt,sequence txt_props)
integer startX,startY,endX,endY
integer strLen
integer firstPixel,lastPixel
integer noAsmTxt,tmp

noAsmTxt=0
startX=txt_coords[1]
startY=txt_coords[2]
strLen=length(txt)
endX=startX+(strLen*txt_props[1][2])+((strLen-1)*txt_props[9])
endY=startY+txt_props[1][3]
if strLen>64 then
txt=txt[1..64]
strLen=64
end if
if startX<0 then
if endX<0 then
noAsmTxt=1
else
tmp=0
while (tmp*txt_props[1][2])<(0-startX) do
tmp=tmp+1
end while
txt=txt[tmp+1..length(txt)]
strLen=strLen-tmp
end if
end if
end procedure

constant asm_disp_code=get_asm(
"pusha cld "&
"mov eax,asm_disp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_disp_x "&
"add ebx,disp_screen_addr "&
"mov edi,ebx "&
"mov ebx,bmp_img_addr "&
"mov esi,ebx "&
"mov ebx,odd_pixel "&
"mov edx,bmp_ydim "&
"xor eax,eax "&
"asmDispLoop: "&
"mov ecx,bmp_xdim "&
"rep movsw "&
"cmp bl,0 "&
"je no_odd_pixel "&
"movsb "&
"no_odd_pixel: "&
"inc eax "&
"cmp eax,edx "&
"je asmDispDone "&
"add edi,disp_offs_add "&
"jmp asmDispLoop "&
"asmDispDone: "&
"popa ret ")
constant asm_disp_x=asm_disp_code+get_param("asm_disp_x")
constant asm_disp_y=asm_disp_code+get_param("asm_disp_y")
constant disp_screen_addr=asm_disp_code+get_param("disp_screen_addr")
constant bmp_img_addr=asm_disp_code+get_param("bmp_img_addr")
constant bmp_xdim=asm_disp_code+get_param("bmp_xdim")
constant bmp_ydim=asm_disp_code+get_param("bmp_ydim")
constant disp_offs_add=asm_disp_code+get_param("disp_offs_add")
constant odd_pixel=asm_disp_code+get_param("odd_pixel")

constant asm_d_disp_code=get_asm(
"pusha cld "&
"mov eax,d_asm_disp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,d_asm_disp_x "&
"add ebx,d_disp_screen_addr "&
"mov edi,ebx "&
"mov ebx,d_bmp_img_addr "&
"mov esi,ebx "&
"mov edx,d_bmp_ydim "&
"xor eax,eax "&
"d_asmDispLoop: "&
"mov ecx,d_bmp_xdim "&
"rep movsd "&
"inc eax "&
"cmp eax,edx "&
"je d_asmDispDone "&
"add edi,d_disp_offs_add "&
"jmp d_asmDispLoop "&
"d_asmDispDone: "&
"popa ret ")
constant d_asm_disp_x=asm_d_disp_code+get_param("d_asm_disp_x")
constant d_asm_disp_y=asm_d_disp_code+get_param("d_asm_disp_y")
constant d_disp_screen_addr=asm_d_disp_code+get_param("d_disp_screen_addr")
constant d_bmp_img_addr=asm_d_disp_code+get_param("d_bmp_img_addr")
constant d_bmp_xdim=asm_d_disp_code+get_param("d_bmp_xdim")
constant d_bmp_ydim=asm_d_disp_code+get_param("d_bmp_ydim")
constant d_disp_offs_add=asm_d_disp_code+get_param("d_disp_offs_add")

constant asm_w_disp_code=get_asm(
"pusha cld "&
"mov eax,w_asm_disp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,w_asm_disp_x "&
"add ebx,w_disp_screen_addr "&
"mov edi,ebx "&
"mov ebx,w_bmp_img_addr "&
"mov esi,ebx "&
"mov edx,w_bmp_ydim "&
"xor eax,eax "&
"w_asmDispLoop: "&
"mov ecx,w_bmp_xdim "&
"rep movsw "&
"inc eax "&
"cmp eax,edx "&
"je w_asmDispDone "&
"add edi,w_disp_offs_add "&
"jmp w_asmDispLoop "&
"w_asmDispDone: "&
"popa ret ")
constant w_asm_disp_x=asm_w_disp_code+get_param("w_asm_disp_x")
constant w_asm_disp_y=asm_w_disp_code+get_param("w_asm_disp_y")
constant w_disp_screen_addr=asm_w_disp_code+get_param("w_disp_screen_addr")
constant w_bmp_img_addr=asm_w_disp_code+get_param("w_bmp_img_addr")
constant w_bmp_xdim=asm_w_disp_code+get_param("w_bmp_xdim")
constant w_bmp_ydim=asm_w_disp_code+get_param("w_bmp_ydim")
constant w_disp_offs_add=asm_w_disp_code+get_param("w_disp_offs_add")

global procedure asm_display(sequence coords,sequence tha_img,atom tha_screen_addr)
integer odd_byte
 odd_byte=tha_img[2]-(floor(tha_img[2]/2)*2)
if floor(tha_img[2]/4)=(tha_img[2]/4) then
 poke4(d_asm_disp_x,coords[1])
 poke(d_asm_disp_y,coords[2])
 poke(d_bmp_xdim,(tha_img[2]/4))
 poke(d_bmp_ydim,tha_img[3])
 poke4(d_disp_offs_add,(320-tha_img[2]))
 poke4(d_bmp_img_addr,(tha_img[1]))
 poke4(d_disp_screen_addr,tha_screen_addr)
 call(asm_d_disp_code)
else if odd_byte=0 then
 poke4(w_asm_disp_x,coords[1])
 poke(w_asm_disp_y,coords[2])
 poke(w_bmp_xdim,(tha_img[2]/2))
 poke(w_bmp_ydim,tha_img[3])
 poke4(w_disp_offs_add,(320-tha_img[2]))
 poke4(w_bmp_img_addr,(tha_img[1]))
 poke4(w_disp_screen_addr,tha_screen_addr)
 call(asm_w_disp_code)
else
 poke4(asm_disp_x,coords[1])
 poke(asm_disp_y,coords[2])
 poke(bmp_xdim,floor(tha_img[2]/2))
 poke(bmp_ydim,tha_img[3])
 poke4(disp_offs_add,(320-tha_img[2]))
 poke4(bmp_img_addr,(tha_img[1]))
 poke4(disp_screen_addr,tha_screen_addr)
 poke(odd_pixel,odd_byte)
 call(asm_disp_code)
end if
end if
end procedure


constant asm_cdisp_code=get_asm(
"pusha cld "&
"mov eax,asm_cdisp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_cdisp_x "&
"add ebx,cdisp_screen_addr "&
"mov edi,ebx "&
"mov ebx,codd_pixel "&
"mov edx,0 "&
"mov edx,cbmp_ydim "&
"xor eax,eax "&
"asmcDispLoop: "&
"mov ecx,cbmp_xdim "&
"mov eax,c_color "&
"rep stosw "&
"cmp bl,0 "&
"je cno_odd_pixel "&
"stosb "&
"cno_odd_pixel: "&
"inc dh "&
"cmp dh,dl "&
"je asmcDispDone "&
"add edi,cdisp_offs_add "&
"jmp asmcDispLoop "&
"asmcDispDone: "&
"popa ret ")
constant asm_cdisp_x=asm_cdisp_code+get_param("asm_cdisp_x")
constant asm_cdisp_y=asm_cdisp_code+get_param("asm_cdisp_y")
constant cdisp_screen_addr=asm_cdisp_code+get_param("cdisp_screen_addr")
constant cbmp_xdim=asm_cdisp_code+get_param("cbmp_xdim")
constant cbmp_ydim=asm_cdisp_code+get_param("cbmp_ydim")
constant cdisp_offs_add=asm_cdisp_code+get_param("cdisp_offs_add")
constant c_color=asm_cdisp_code+get_param("c_color")
constant codd_pixel=asm_cdisp_code+get_param("codd_pixel")

global procedure asm_cdisplay(sequence coords,sequence tha_img,integer tha_col,atom tha_screen_addr)
poke4(asm_cdisp_x,coords[1])
poke(asm_cdisp_y,coords[2])
poke(cbmp_xdim,floor(tha_img[2]/2))
poke(cbmp_ydim,tha_img[3])
poke4(cdisp_offs_add,(320-tha_img[2]))
poke4(cdisp_screen_addr,tha_screen_addr)
poke4(c_color,(tha_col*256)+tha_col)
poke(codd_pixel,tha_img[2]-(floor(tha_img[2]/2)*2))
call(asm_cdisp_code)
end procedure



constant asm_scale_disp_code=get_asm(
"pusha cld "&
"mov eax,asm_sdisp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_sdisp_x "&
"add ebx,sdisp_screen_addr "&
"mov edi,ebx "&
"mov edx,sbmp_ydim "&
"mov dh,0 "&
"xor ebx,ebx "&
"mov esi,sbmp_img_addr "&
"asmsDispLoop: "&
"mov ecx,sbmp_xdim "&
"asmsXloop: "&
"mov esi,sbmp_img_addr "&
"mov eax,ebx "&
"shr ebx,15 "&
"add esi,ebx "&
"movsb "&
"mov ebx,eax "&
"mov eax,spriteXstep "&
"add ebx,eax "&
"loop asmsXloop "&
"dec dl "&
"cmp dl,0 "&
"je asmsDispDone "&
"inc dh "&
"push edx "&
"add edi,sdisp_offs_add "&
"xor eax,eax "&
"mov al,dh "&
"mov ebx,spriteYstep "&
"imul ebx "&
"shr eax,15 "&
"mov ebx,sspriteXdims "&
"imul ebx "&
"shl eax,15 "&
"mov ebx,eax "&
"pop edx "&
"jmp asmsDispLoop "&
"asmsDispDone: "&
"popa ret ")
constant asm_sdisp_x=asm_scale_disp_code+get_param("asm_sdisp_x")
constant asm_sdisp_y=asm_scale_disp_code+get_param("asm_sdisp_y")
constant sdisp_screen_addr=asm_scale_disp_code+get_param("sdisp_screen_addr")
constant sbmp_img_addr=asm_scale_disp_code+get_param("sbmp_img_addr")
constant sbmp_xdim=asm_scale_disp_code+get_param("sbmp_xdim")
constant sbmp_ydim=asm_scale_disp_code+get_param("sbmp_ydim")
constant sdisp_offs_add=asm_scale_disp_code+get_param("sdisp_offs_add")
constant spriteXstep=asm_scale_disp_code+get_param("spriteXstep")
constant spriteYstep=asm_scale_disp_code+get_param("spriteYstep")
constant sspriteXdims=asm_scale_disp_code+get_param("sspriteXdims")

global procedure asm_sdisplay(sequence coords,sequence tha_img,sequence spt_dims,atom tha_screen_addr)
poke4(asm_sdisp_x,coords[1])
poke(asm_sdisp_y,coords[2])
poke4(sbmp_xdim,spt_dims[1])
poke(sbmp_ydim,spt_dims[2])
poke4(sspriteXdims,tha_img[2])
poke4(sbmp_img_addr,tha_img[1])
poke4(sdisp_offs_add,(320-spt_dims[1]))
poke4(sdisp_screen_addr,tha_screen_addr)
poke4(spriteXstep,floor((tha_img[2]/spt_dims[1])*32768))
poke4(spriteYstep,floor(((tha_img[3]/spt_dims[2]))*32768))
call(asm_scale_disp_code)
end procedure





constant asm_scale_tdisp_code=get_asm(
"pusha cld "&
"mov eax,asm_stdisp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_stdisp_x "&
"add ebx,stdisp_screen_addr "&
"mov edi,ebx "&
"mov edx,stbmp_ydim "&
"mov dh,0 "&
"xor ebx,ebx "&
"mov esi,stbmp_img_addr "&
"asmstDispLoop: "&
"mov ecx,stbmp_xdim "&
"asmstXloop: "&
"mov esi,stbmp_img_addr "&
"mov eax,ebx "&
"shr ebx,15 "&
"add esi,ebx "&
"lodsb "&
"cmp al,0 "&
"je st_black_pixel "&
"stosb "&
"jmp st_noadd "&
"st_black_pixel: "&
"inc edi "&
"st_noadd: "&
"mov ebx,eax "&
"mov eax,tspriteXstep "&
"add ebx,eax "&
"loop asmstXloop "&
"dec dl "&
"cmp dl,0 "&
"je asmstDispDone "&
"inc dh "&
"push edx "&
"add edi,stdisp_offs_add "&
"xor eax,eax "&
"mov al,dh "&
"mov ebx,tspriteYstep "&
"imul ebx "&
"shr eax,15 "&
"mov ebx,stspriteXdims "&
"imul ebx "&
"shl eax,15 "&
"mov ebx,eax "&
"pop edx "&
"jmp asmstDispLoop "&
"asmstDispDone: "&
"popa ret ")
constant asm_stdisp_x=asm_scale_tdisp_code+get_param("asm_stdisp_x")
constant asm_stdisp_y=asm_scale_tdisp_code+get_param("asm_stdisp_y")
constant stdisp_screen_addr=asm_scale_tdisp_code+get_param("stdisp_screen_addr")
constant stbmp_img_addr=asm_scale_tdisp_code+get_param("stbmp_img_addr")
constant stbmp_xdim=asm_scale_tdisp_code+get_param("stbmp_xdim")
constant stbmp_ydim=asm_scale_tdisp_code+get_param("stbmp_ydim")
constant stdisp_offs_add=asm_scale_tdisp_code+get_param("stdisp_offs_add")
constant tspriteXstep=asm_scale_tdisp_code+get_param("tspriteXstep")
constant tspriteYstep=asm_scale_tdisp_code+get_param("tspriteYstep")
constant stspriteXdims=asm_scale_tdisp_code+get_param("stspriteXdims")

global procedure asm_stdisplay(sequence coords,sequence tha_img,sequence spt_dims,atom tha_screen_addr)
poke4(asm_stdisp_x,coords[1])
poke(asm_stdisp_y,coords[2])
poke4(stbmp_xdim,spt_dims[1])
poke(stbmp_ydim,spt_dims[2])
poke4(stspriteXdims,tha_img[2])
poke4(stbmp_img_addr,tha_img[1])
poke4(stdisp_offs_add,(320-spt_dims[1]))
poke4(stdisp_screen_addr,tha_screen_addr)
poke4(tspriteXstep,floor((tha_img[2]/spt_dims[1])*32768))
poke4(tspriteYstep,floor(((tha_img[3]/spt_dims[2]))*32768))
call(asm_scale_tdisp_code)
end procedure



constant asm_tdisp_code=get_asm(
"pusha cld "&
"mov eax,asm_tdisp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_tdisp_x "&
"add ebx,tdisp_screen_addr "&
"mov edi,ebx "&
"mov ebx,tbmp_img_addr "&
"mov esi,ebx "&
"mov edx,tbmp_ydim "&
"xor ebx,ebx "&
"asmtDispLoop: "&
"mov ecx,tbmp_xdim "&
"asmtDispLoop2: "&
"lodsb "&
"cmp al,0 "&
"je tblack_pixel "&
"stosb "&
"jmp tno_add "&
"tblack_pixel: "&
"inc edi "&
"tno_add: "&
"loop asmtDispLoop2 "&
"inc ebx "&
"cmp ebx,edx "&
"je asmtDispDone "&
"add edi,tdisp_offs_add "&
"jmp asmtDispLoop "&
"asmtDispDone: "&
"popa ret ")
constant asm_tdisp_x=asm_tdisp_code+get_param("asm_tdisp_x")
constant asm_tdisp_y=asm_tdisp_code+get_param("asm_tdisp_y")
constant tdisp_screen_addr=asm_tdisp_code+get_param("tdisp_screen_addr")
constant tbmp_img_addr=asm_tdisp_code+get_param("tbmp_img_addr")
constant tbmp_xdim=asm_tdisp_code+get_param("tbmp_xdim")
constant tbmp_ydim=asm_tdisp_code+get_param("tbmp_ydim")
constant tdisp_offs_add=asm_tdisp_code+get_param("tdisp_offs_add")


global procedure asm_tdisplay(sequence coords,sequence tha_img,atom tha_screen_addr)
poke4(asm_tdisp_x,coords[1])
poke(asm_tdisp_y,coords[2])
poke4(tbmp_xdim,tha_img[2])
poke(tbmp_ydim,tha_img[3])
poke4(tdisp_offs_add,(320-tha_img[2]))
poke4(tbmp_img_addr,(tha_img[1]))
poke4(tdisp_screen_addr,tha_screen_addr)
call(asm_tdisp_code)
end procedure



constant asm_ctdisp_code=get_asm(
"pusha cld "&
"mov eax,asm_ctdisp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_ctdisp_x "&
"add ebx,ctdisp_screen_addr "&
"mov edi,ebx "&
"mov ebx,ctbmp_img_addr "&
"mov esi,ebx "&
"mov edx,ctbmp_ydim "&
"xor ebx,ebx "&
"asmctDispLoop: "&
"mov ecx,ctbmp_xdim "&
"asmctDispLoop2: "&
"lodsb "&
"cmp al,0 "&
"je cblackPixel "&
"mov eax,ct_color "&
"stosb "&
"jmp ctno_add "&
"cblackPixel: "&
"inc edi "&
"ctno_add: "&
"loop asmctDispLoop2 "&
"inc ebx "&
"cmp ebx,edx "&
"je asmctDispDone "&
"add edi,ctdisp_offs_add "&
"jmp asmctDispLoop "&
"asmctDispDone: "&
"popa ret ")
constant asm_ctdisp_x=asm_ctdisp_code+get_param("asm_ctdisp_x")
constant asm_ctdisp_y=asm_ctdisp_code+get_param("asm_ctdisp_y")
constant ctdisp_screen_addr=asm_ctdisp_code+get_param("ctdisp_screen_addr")
constant ctbmp_img_addr=asm_ctdisp_code+get_param("ctbmp_img_addr")
constant ctbmp_xdim=asm_ctdisp_code+get_param("ctbmp_xdim")
constant ctbmp_ydim=asm_ctdisp_code+get_param("ctbmp_ydim")
constant ctdisp_offs_add=asm_ctdisp_code+get_param("ctdisp_offs_add")
constant ct_color=asm_ctdisp_code+get_param("ct_color")


global procedure asm_ctdisplay(sequence coords,sequence tha_img,integer tha_col,atom tha_screen_addr)
poke4(asm_ctdisp_x,coords[1])
poke(asm_ctdisp_y,coords[2])
poke4(ctbmp_xdim,tha_img[2])
poke(ctbmp_ydim,tha_img[3])
poke4(ctdisp_offs_add,(320-tha_img[2]))
poke4(ctbmp_img_addr,(tha_img[1]))
poke4(ctdisp_screen_addr,tha_screen_addr)
poke(ct_color,tha_col)
call(asm_ctdisp_code)
end procedure



constant asm_d_dispclip_code=get_asm(
"pusha cld "&
"mov eax,d_asm_dispclip_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,d_asm_dispclip_x "&
"add ebx,d_dispclip_screen_addr "&
"mov edi,ebx "&
"mov ebx,d_clipbmp_img_addr "&
"mov esi,ebx "&
"mov edx,d_clipbmp_ydim "&
"xor eax,eax "&
"d_asmDispclipLoop: "&
"mov ecx,d_clipbmp_xdim "&
"rep movsd "&
"inc eax "&
"cmp eax,edx "&
"je d_asmDispclipDone "&
"add edi,d_dispclip_offs_add "&
"add esi,d_clipimg_offs_add "&
"jmp d_asmDispclipLoop "&
"d_asmDispclipDone: "&
"popa ret ")
constant d_asm_dispclip_x=asm_d_dispclip_code+get_param("d_asm_dispclip_x")
constant d_asm_dispclip_y=asm_d_dispclip_code+get_param("d_asm_dispclip_y")
constant d_dispclip_screen_addr=asm_d_dispclip_code+get_param("d_dispclip_screen_addr")
constant d_clipbmp_img_addr=asm_d_dispclip_code+get_param("d_clipbmp_img_addr")
constant d_clipbmp_xdim=asm_d_dispclip_code+get_param("d_clipbmp_xdim")
constant d_clipbmp_ydim=asm_d_dispclip_code+get_param("d_clipbmp_ydim")
constant d_dispclip_offs_add=asm_d_dispclip_code+get_param("d_dispclip_offs_add")
constant d_clipimg_offs_add=asm_d_dispclip_code+get_param("d_clipimg_offs_add")
--constant d_clip_odd_pixel=asm_d_dispclip_code+get_param("d_clip_odd_pixel")



constant asm_w_dispclip_code=get_asm(
"pusha cld "&
"mov eax,w_asm_dispclip_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,w_asm_dispclip_x "&
"add ebx,w_dispclip_screen_addr "&
"mov edi,ebx "&
"mov ebx,w_clipbmp_img_addr "&
"mov esi,ebx "&
"mov edx,w_clipbmp_ydim "&
"xor eax,eax "&
"w_asmDispclipLoop: "&
"mov ecx,w_clipbmp_xdim "&
"rep movsw "&
"inc eax "&
"cmp eax,edx "&
"je w_asmDispclipDone "&
"add edi,w_dispclip_offs_add "&
"add esi,w_clipimg_offs_add "&
"jmp w_asmDispclipLoop "&
"w_asmDispclipDone: "&
"popa ret ")
constant w_asm_dispclip_x=asm_w_dispclip_code+get_param("w_asm_dispclip_x")
constant w_asm_dispclip_y=asm_w_dispclip_code+get_param("w_asm_dispclip_y")
constant w_dispclip_screen_addr=asm_w_dispclip_code+get_param("w_dispclip_screen_addr")
constant w_clipbmp_img_addr=asm_w_dispclip_code+get_param("w_clipbmp_img_addr")
constant w_clipbmp_xdim=asm_w_dispclip_code+get_param("w_clipbmp_xdim")
constant w_clipbmp_ydim=asm_w_dispclip_code+get_param("w_clipbmp_ydim")
constant w_dispclip_offs_add=asm_w_dispclip_code+get_param("w_dispclip_offs_add")
constant w_clipimg_offs_add=asm_w_dispclip_code+get_param("w_clipimg_offs_add")
--constant w_clip_odd_pixel=asm_w_dispclip_code+get_param("w_clip_odd_pixel")





constant asm_dispclip_code=get_asm(
"pusha cld "&
"mov eax,asm_dispclip_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_dispclip_x "&
"add ebx,dispclip_screen_addr "&
"mov edi,ebx "&
"mov ebx,clipbmp_img_addr "&
"mov esi,ebx "&
"mov edx,clipbmp_ydim "&
"xor eax,eax "&
"asmDispclipLoop: "&
"mov ecx,clipbmp_xdim "&
"rep movsw "&
"movsb "&
"inc eax "&
"cmp eax,edx "&
"je asmDispclipDone "&
"add edi,dispclip_offs_add "&
"add esi,clipimg_offs_add "&
"jmp asmDispclipLoop "&
"asmDispclipDone: "&
"popa ret ")
constant asm_dispclip_x=asm_dispclip_code+get_param("asm_dispclip_x")
constant asm_dispclip_y=asm_dispclip_code+get_param("asm_dispclip_y")
constant dispclip_screen_addr=asm_dispclip_code+get_param("dispclip_screen_addr")
constant clipbmp_img_addr=asm_dispclip_code+get_param("clipbmp_img_addr")
constant clipbmp_xdim=asm_dispclip_code+get_param("clipbmp_xdim")
constant clipbmp_ydim=asm_dispclip_code+get_param("clipbmp_ydim")
constant dispclip_offs_add=asm_dispclip_code+get_param("dispclip_offs_add")
constant clipimg_offs_add=asm_dispclip_code+get_param("clipimg_offs_add")
--constant clip_odd_pixel=asm_dispclip_code+get_param("clip_odd_pixel")

global procedure asm_display_clip(sequence coords,sequence tha_img,atom tha_screen_addr)
integer bmpXdim,bmpYdim,xEnd,yEnd
integer clippedXdim,clippedYdim
integer clipX,clipY,xLen,yLen
integer startOffsAdd,clipOffsAdd,noDisp
integer odd_byte
bmpXdim=(tha_img[2])
bmpYdim=(tha_img[3])
xLen=bmpXdim
yLen=bmpYdim
startOffsAdd=0
clipOffsAdd=0
clipX=coords[1]
clipY=coords[2]
xEnd=(coords[1]+bmpXdim-1)
yEnd=(coords[2]+bmpYdim-1)
noDisp=0
if coords[1]<clip_box_coords[1][1] then
if xEnd<clip_box_coords[1][1] then
noDisp=1
end if
clipX=clip_box_coords[1][1]
startOffsAdd=clipX-coords[1]
clipOffsAdd=startOffsAdd
xLen=xLen-startOffsAdd
end if
if coords[2]<clip_box_coords[1][2] then
if yEnd<clip_box_coords[1][2] then
noDisp=1
end if
clipY=clip_box_coords[1][2]
startOffsAdd=startOffsAdd+((clipY-coords[2])*bmpXdim)
yLen=yLen-(clipY-coords[2])
end if
if (coords[1]>clip_box_coords[2][1]) or (coords[2]>clip_box_coords[2][2]) then
noDisp=1
end if
if xEnd>clip_box_coords[2][1] then
xLen=xLen-(xEnd-clip_box_coords[2][1])
clipOffsAdd=clipOffsAdd+(xEnd-clip_box_coords[2][1])
end if
if yEnd>clip_box_coords[2][2] then
yLen=yLen-(yEnd-clip_box_coords[2][2])
end if
if noDisp=0 then


 odd_byte=xLen-(floor(xLen/2)*2)
if floor(xLen/4)=(xLen/4) then
 poke4(d_asm_dispclip_x,clipX)
 poke(d_asm_dispclip_y,clipY)
 poke(d_clipbmp_xdim,floor(xLen/4))
 poke(d_clipbmp_ydim,yLen)
 poke4(d_dispclip_offs_add,(320-xLen))
 poke4(d_clipbmp_img_addr,(tha_img[1])+startOffsAdd)
 poke4(d_dispclip_screen_addr,tha_screen_addr)
 poke4(d_clipimg_offs_add,clipOffsAdd)
 call(asm_d_dispclip_code)
else if odd_byte=0 then
 poke4(w_asm_dispclip_x,clipX)
 poke(w_asm_dispclip_y,clipY)
 poke(w_clipbmp_xdim,floor(xLen/2))
 poke(w_clipbmp_ydim,yLen)
 poke4(w_dispclip_offs_add,(320-xLen))
 poke4(w_clipbmp_img_addr,(tha_img[1])+startOffsAdd)
 poke4(w_dispclip_screen_addr,tha_screen_addr)
 poke4(w_clipimg_offs_add,clipOffsAdd)
 call(asm_w_dispclip_code)
else
 poke4(asm_dispclip_x,clipX)
 poke(asm_dispclip_y,clipY)
 poke(clipbmp_xdim,floor(xLen/2))
 poke(clipbmp_ydim,yLen)
 poke4(dispclip_offs_add,(320-xLen))
 poke4(clipbmp_img_addr,(tha_img[1])+startOffsAdd)
 poke4(dispclip_screen_addr,tha_screen_addr)
 poke4(clipimg_offs_add,clipOffsAdd)
 --poke(clip_odd_pixel,odd_byte)
 call(asm_dispclip_code)
end if
end if
--poke4(asm_dispclip_x,clipX)
--poke(asm_dispclip_y,clipY)
--poke(clipbmp_xdim,floor(xLen/2))
--poke(clipbmp_ydim,yLen)
--poke4(dispclip_offs_add,(320-xLen))
--poke4(clipbmp_img_addr,(tha_img[1])+startOffsAdd)
--poke4(dispclip_screen_addr,tha_screen_addr)
--poke4(clipimg_offs_add,clipOffsAdd)
--poke(clip_odd_pixel,xLen-(floor(xLen/2)*2))
--call(asm_dispclip_code)
end if
end procedure




constant asm_scale_disp_clip_code=get_asm(
"pusha cld "&
"mov eax,asm_scdisp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_scdisp_x "&
"add ebx,scdisp_screen_addr "&
"mov edi,ebx "&
"mov edx,scbmp_ydim "&
"mov dh,0 "&
"xor ebx,ebx "&
"mov esi,scbmp_img_addr "&
"asmscDispLoop: "&
"mov ecx,scbmp_xdim "&
"asmscXloop: "&
"mov esi,scbmp_img_addr "&
"mov eax,ebx "&
"shr ebx,15 "&
"add esi,ebx "&
"movsb "&
"mov ebx,eax "&
"mov eax,cspriteXstep "&
"add ebx,eax "&
"loop asmscXloop "&
"dec dl "&
"cmp dl,0 "&
"je asmscDispDone "&
"inc dh "&
"push edx "&
"add edi,scdisp_offs_add "&
"xor eax,eax "&
"mov al,dh "&
"mov ebx,cspriteYstep "&
"imul ebx "&
"shr eax,15 "&
"mov ebx,scspriteXdims "&
"imul ebx "&
"shl eax,15 "&
"mov ebx,eax "&
"pop edx "&
"jmp asmscDispLoop "&
"asmscDispDone: "&
"popa ret ")
constant asm_scdisp_x=asm_scale_disp_clip_code+get_param("asm_scdisp_x")
constant asm_scdisp_y=asm_scale_disp_clip_code+get_param("asm_scdisp_y")
constant scdisp_screen_addr=asm_scale_disp_clip_code+get_param("scdisp_screen_addr")
constant scbmp_img_addr=asm_scale_disp_clip_code+get_param("scbmp_img_addr")
constant scbmp_xdim=asm_scale_disp_clip_code+get_param("scbmp_xdim")
constant scbmp_ydim=asm_scale_disp_clip_code+get_param("scbmp_ydim")
constant scdisp_offs_add=asm_scale_disp_clip_code+get_param("scdisp_offs_add")
constant cspriteXstep=asm_scale_disp_clip_code+get_param("cspriteXstep")
constant cspriteYstep=asm_scale_disp_clip_code+get_param("cspriteYstep")
constant scspriteXdims=asm_scale_disp_clip_code+get_param("scspriteXdims")



global procedure asm_sdisplay_clip(sequence coords,sequence tha_img,sequence spt_dims,atom tha_screen_addr)
integer no_disp,esi_add
integer xLen,yLen
atom xstep,ystep
xstep=(tha_img[2]/spt_dims[1])
ystep=(tha_img[3]/spt_dims[2])
no_disp=0
esi_add=0
xLen=spt_dims[1]
yLen=spt_dims[2]
if coords[1]<clip_box_coords[1][1] then
if (coords[1]+spt_dims[1]-1)<clip_box_coords[1][1] then
no_disp=1
else
esi_add=esi_add+floor(xstep*diff(coords[1],clip_box_coords[1][1]))
xLen=xLen-diff(coords[1],clip_box_coords[1][1])
coords[1]=0
end if
end if
if coords[2]<clip_box_coords[1][2] then
if (coords[2]+spt_dims[2]-1)<clip_box_coords[1][2] then
no_disp=1
else
esi_add=esi_add+floor((tha_img[2]*ystep*diff(coords[2],clip_box_coords[1][2]))/tha_img[2])*tha_img[2]
yLen=yLen-diff(coords[2],clip_box_coords[1][2])
coords[2]=0
end if
end if
spt_dims={xLen,yLen}
if (coords[1]+spt_dims[1]-1)>clip_box_coords[2][1] then
if coords[1]>clip_box_coords[2][1] then
no_disp=1
else
xLen=xLen-diff((coords[1]+spt_dims[1]-1),clip_box_coords[2][1])
end if
end if
if (coords[2]+spt_dims[2]-1)>clip_box_coords[2][2] then
if coords[2]>clip_box_coords[2][2] then
no_disp=1
else
yLen=yLen-diff((coords[2]+spt_dims[2]-1),clip_box_coords[2][2])
end if
end if
spt_dims={xLen,yLen}
if no_disp=0 then
poke4(asm_scdisp_x,coords[1])
poke(asm_scdisp_y,coords[2])
poke4(scbmp_xdim,spt_dims[1])
poke(scbmp_ydim,spt_dims[2])
poke4(scspriteXdims,tha_img[2])
poke4(scbmp_img_addr,tha_img[1]+esi_add)
poke4(scdisp_offs_add,(320-spt_dims[1]))
poke4(scdisp_screen_addr,tha_screen_addr)
poke4(cspriteXstep,floor(xstep*32768))
poke4(cspriteYstep,floor(ystep*32768))
call(asm_scale_disp_clip_code)
end if
end procedure



constant asm_scale_tdisp_clip_code=get_asm(
"pusha cld "&
"mov eax,asm_stcdisp_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_stcdisp_x "&
"add ebx,stcdisp_screen_addr "&
"mov edi,ebx "&
"mov edx,stcbmp_ydim "&
"mov dh,0 "&
"xor ebx,ebx "&
"mov esi,stcbmp_img_addr "&
"asmstcDispLoop: "&
"mov ecx,stcbmp_xdim "&
"asmstcXloop: "&
"mov esi,stcbmp_img_addr "&
"mov eax,ebx "&
"shr ebx,15 "&
"add esi,ebx "&
"lodsb "&
"cmp al,0 "&
"je stc_black_pixel "&
"stosb "&
"jmp stc_noadd "&
"stc_black_pixel: "&
"inc edi "&
"stc_noadd: "&
"mov ebx,eax "&
"mov eax,tcspriteXstep "&
"add ebx,eax "&
"loop asmstcXloop "&
"dec dl "&
"cmp dl,0 "&
"je asmstcDispDone "&
"inc dh "&
"push edx "&
"add edi,stcdisp_offs_add "&
"xor eax,eax "&
"mov al,dh "&
"mov ebx,tcspriteYstep "&
"imul ebx "&
"shr eax,15 "&
"mov ebx,stcspriteXdims "&
"imul ebx "&
"shl eax,15 "&
"mov ebx,eax "&
"pop edx "&
"jmp asmstcDispLoop "&
"asmstcDispDone: "&
"popa ret ")
constant asm_stcdisp_x=asm_scale_tdisp_clip_code+get_param("asm_stcdisp_x")
constant asm_stcdisp_y=asm_scale_tdisp_clip_code+get_param("asm_stcdisp_y")
constant stcdisp_screen_addr=asm_scale_tdisp_clip_code+get_param("stcdisp_screen_addr")
constant stcbmp_img_addr=asm_scale_tdisp_clip_code+get_param("stcbmp_img_addr")
constant stcbmp_xdim=asm_scale_tdisp_clip_code+get_param("stcbmp_xdim")
constant stcbmp_ydim=asm_scale_tdisp_clip_code+get_param("stcbmp_ydim")
constant stcdisp_offs_add=asm_scale_tdisp_clip_code+get_param("stcdisp_offs_add")
constant tcspriteXstep=asm_scale_tdisp_clip_code+get_param("tcspriteXstep")
constant tcspriteYstep=asm_scale_tdisp_clip_code+get_param("tcspriteYstep")
constant stcspriteXdims=asm_scale_tdisp_clip_code+get_param("stcspriteXdims")



global procedure asm_stdisplay_clip(sequence coords,sequence tha_img,sequence spt_dims,atom tha_screen_addr)
integer no_disp,esi_add
integer xLen,yLen
atom xstep,ystep
xstep=(tha_img[2]/spt_dims[1])
ystep=(tha_img[3]/spt_dims[2])
no_disp=0
esi_add=0
xLen=spt_dims[1]
yLen=spt_dims[2]
if coords[1]<clip_box_coords[1][1] then
if (coords[1]+spt_dims[1]-1)<clip_box_coords[1][1] then
no_disp=1
else
esi_add=esi_add+floor(xstep*diff(coords[1],clip_box_coords[1][1]))
xLen=xLen-diff(coords[1],clip_box_coords[1][1])
coords[1]=clip_box_coords[1][1]
end if
end if
if coords[2]<clip_box_coords[1][2] then
if (coords[2]+spt_dims[2]-1)<clip_box_coords[1][2] then
no_disp=1
else
esi_add=esi_add+floor((tha_img[2]*ystep*diff(coords[2],clip_box_coords[1][2]))/tha_img[2])*tha_img[2]
yLen=yLen-diff(coords[2],clip_box_coords[1][2])
coords[2]=clip_box_coords[1][2]
end if
end if
spt_dims={xLen,yLen}
if (coords[1]+spt_dims[1]-1)>clip_box_coords[2][1] then
if coords[1]>clip_box_coords[2][1] then
no_disp=1
else
xLen=xLen-diff((coords[1]+spt_dims[1]-1),clip_box_coords[2][1])
end if
end if
if (coords[2]+spt_dims[2]-1)>clip_box_coords[2][2] then
if coords[2]>clip_box_coords[2][2] then
no_disp=1
else
yLen=yLen-diff((coords[2]+spt_dims[2]-1),clip_box_coords[2][2])
end if
end if
spt_dims={xLen,yLen}
if no_disp=0 then
poke4(asm_stcdisp_x,coords[1])
poke(asm_stcdisp_y,coords[2])
poke4(stcbmp_xdim,spt_dims[1])
poke(stcbmp_ydim,spt_dims[2])
poke4(stcspriteXdims,tha_img[2])
poke4(stcbmp_img_addr,tha_img[1]+esi_add)
poke4(stcdisp_offs_add,(320-spt_dims[1]))
poke4(stcdisp_screen_addr,tha_screen_addr)
poke4(tcspriteXstep,floor(xstep*32768))
poke4(tcspriteYstep,floor(ystep*32768))
call(asm_scale_tdisp_clip_code)
end if
end procedure




constant asm_cdispclip_code=get_asm(
"pusha cld "&
"mov eax,asm_cdispclip_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_cdispclip_x "&
"add ebx,cdispclip_screen_addr "&
"mov edi,ebx "&
"mov edx,cclipbmp_ydim "&
"mov ebx,cclip_odd_pixel "&
"xor eax,eax "&
"asmcDispclipLoop: "&
"mov ecx,cclipbmp_xdim "&
"push eax "&
"mov eax,cclip_color "&
"rep stosw "&
"cmp bl,0 "&
"je cclip_no_odd_pixel "&
"stosb "&
"cclip_no_odd_pixel: "&
"pop eax "&
"inc eax "&
"cmp eax,edx "&
"je asmcDispclipDone "&
"add edi,cdispclip_offs_add "&
"jmp asmcDispclipLoop "&
"asmcDispclipDone: "&
"popa ret ")
constant asm_cdispclip_x=asm_cdispclip_code+get_param("asm_cdispclip_x")
constant asm_cdispclip_y=asm_cdispclip_code+get_param("asm_cdispclip_y")
constant cdispclip_screen_addr=asm_cdispclip_code+get_param("cdispclip_screen_addr")
constant cclipbmp_xdim=asm_cdispclip_code+get_param("cclipbmp_xdim")
constant cclipbmp_ydim=asm_cdispclip_code+get_param("cclipbmp_ydim")
constant cdispclip_offs_add=asm_cdispclip_code+get_param("cdispclip_offs_add")
constant cclip_color=asm_cdispclip_code+get_param("cclip_color")
constant cclip_odd_pixel=asm_cdispclip_code+get_param("cclip_odd_pixel")

global procedure asm_cdisplay_clip(sequence coords,sequence tha_img,integer cColor,
atom tha_screen_addr)
integer bmpXdim,bmpYdim,xEnd,yEnd
integer clippedXdim,clippedYdim
integer clipX,clipY,xLen,yLen
integer startOffsAdd,clipOffsAdd,noDisp
bmpXdim=(tha_img[2])
bmpYdim=(tha_img[3])
xLen=bmpXdim
yLen=bmpYdim
startOffsAdd=0
clipOffsAdd=0
clipX=coords[1]
clipY=coords[2]
xEnd=(coords[1]+bmpXdim-1)
yEnd=(coords[2]+bmpYdim-1)
noDisp=0
if coords[1]<clip_box_coords[1][1] then
if xEnd<clip_box_coords[1][1] then
noDisp=1
end if
clipX=clip_box_coords[1][1]
startOffsAdd=clipX-coords[1]
clipOffsAdd=startOffsAdd
xLen=xLen-startOffsAdd
end if
if coords[2]<clip_box_coords[1][2] then
if yEnd<clip_box_coords[1][2] then
noDisp=1
end if
clipY=clip_box_coords[1][2]
startOffsAdd=startOffsAdd+((clipY-coords[2])*bmpXdim)
yLen=yLen-(clipY-coords[2])
end if
if (coords[1]>clip_box_coords[2][1]) or (coords[2]>clip_box_coords[2][2]) then
noDisp=1
end if
if xEnd>clip_box_coords[2][1] then
xLen=xLen-(xEnd-clip_box_coords[2][1])
clipOffsAdd=clipOffsAdd+(xEnd-clip_box_coords[2][1])
end if
if yEnd>clip_box_coords[2][2] then
yLen=yLen-(yEnd-clip_box_coords[2][2])
end if
if noDisp=0 then
poke4(asm_cdispclip_x,clipX)
poke(asm_cdispclip_y,clipY)
poke(cclipbmp_xdim,floor(xLen/2))
poke(cclipbmp_ydim,yLen)
poke4(cdispclip_offs_add,(320-xLen))
poke4(cclip_color,(cColor*256)+cColor)
poke4(cdispclip_screen_addr,tha_screen_addr)
poke(cclip_odd_pixel,xLen-(floor(xLen/2)*2))
call(asm_cdispclip_code)
end if
end procedure




constant asm_tdispclip_code=get_asm(
"pusha cld "&
"mov eax,asm_tdispclip_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_tdispclip_x "&
"add ebx,tdispclip_screen_addr "&
"mov edi,ebx "&
"mov ebx,tclipbmp_img_addr "&
"mov esi,ebx "&
"mov edx,tclipbmp_ydim "&
"xor ebx,ebx "&
"asmtDispclipLoop: "&
"mov ecx,tclipbmp_xdim "&
"asmtDispclipLoop2: "&
"lodsb "&
"cmp al,0 "&
"je tclip_black_pixel "&
"stosb "&
"jmp tclip_no_add "&
"tclip_black_pixel: "&
"inc edi "&
"tclip_no_add: "&
"loop asmtDispclipLoop2 "&
"inc ebx "&
"cmp ebx,edx "&
"je asmtDispclipDone "&
"add edi,tdispclip_offs_add "&
"add esi,tclipimg_offs_add "&
"jmp asmtDispclipLoop "&
"asmtDispclipDone: "&
"popa ret ")
constant asm_tdispclip_x=asm_tdispclip_code+get_param("asm_tdispclip_x")
constant asm_tdispclip_y=asm_tdispclip_code+get_param("asm_tdispclip_y")
constant tdispclip_screen_addr=asm_tdispclip_code+get_param("tdispclip_screen_addr")
constant tclipbmp_img_addr=asm_tdispclip_code+get_param("tclipbmp_img_addr")
constant tclipbmp_xdim=asm_tdispclip_code+get_param("tclipbmp_xdim")
constant tclipbmp_ydim=asm_tdispclip_code+get_param("tclipbmp_ydim")
constant tdispclip_offs_add=asm_tdispclip_code+get_param("tdispclip_offs_add")
constant tclipimg_offs_add=asm_tdispclip_code+get_param("tclipimg_offs_add")

global procedure asm_tdisplay_clip(sequence tcoords,sequence ttha_img,atom ttha_screen_addr)
integer tbmpXdim,tbmpYdim,txEnd,tyEnd
integer tclippedXdim,tclippedYdim
integer tclipX,tclipY,txLen,tyLen
integer tstartOffsAdd,tclipOffsAdd,tnoDisp
tbmpXdim=(ttha_img[2])
tbmpYdim=(ttha_img[3])
txLen=tbmpXdim
tyLen=tbmpYdim
tstartOffsAdd=0
tclipOffsAdd=0
tclipX=tcoords[1]
tclipY=tcoords[2]
txEnd=(tcoords[1]+tbmpXdim-1)
tyEnd=(tcoords[2]+tbmpYdim-1)
tnoDisp=0
if tcoords[1]<clip_box_coords[1][1] then
if txEnd<clip_box_coords[1][1] then
tnoDisp=1
end if
tclipX=clip_box_coords[1][1]
tstartOffsAdd=tclipX-tcoords[1]
tclipOffsAdd=tstartOffsAdd
txLen=txLen-tstartOffsAdd
end if
if tcoords[2]<clip_box_coords[1][2] then
if tyEnd<clip_box_coords[1][2] then
tnoDisp=1
end if
tclipY=clip_box_coords[1][2]
tstartOffsAdd=tstartOffsAdd+((tclipY-tcoords[2])*tbmpXdim)
tyLen=tyLen-(tclipY-tcoords[2])
end if
if (tcoords[1]>clip_box_coords[2][1]) or (tcoords[2]>clip_box_coords[2][2]) then
tnoDisp=1
end if
if txEnd>clip_box_coords[2][1] then
txLen=txLen-(txEnd-clip_box_coords[2][1])
tclipOffsAdd=tclipOffsAdd+(txEnd-clip_box_coords[2][1])
end if
if tyEnd>clip_box_coords[2][2] then
tyLen=tyLen-(tyEnd-clip_box_coords[2][2])
end if
if (tnoDisp=0) then
poke4(asm_tdispclip_x,tclipX)
poke(asm_tdispclip_y,tclipY)
poke4(tclipbmp_xdim,txLen)
poke(tclipbmp_ydim,tyLen)
poke4(tdispclip_offs_add,(320-txLen))
poke4(tclipbmp_img_addr,(ttha_img[1])+tstartOffsAdd)
poke4(tdispclip_screen_addr,ttha_screen_addr)
poke4(tclipimg_offs_add,tclipOffsAdd)
call(asm_tdispclip_code)
end if
end procedure




constant asm_ctdispclip_code=get_asm(
"pusha cld "&
"mov eax,asm_ctdispclip_y "&
"shl eax,6 "&
"mov ebx,eax "&
"shl eax,2 "&
"add ebx,eax "&
"add ebx,asm_ctdispclip_x "&
"add ebx,ctdispclip_screen_addr "&
"mov edi,ebx "&
"mov edx,ctclipbmp_ydim "&
"mov ebx,ctclipbmp_img_addr "&
"mov esi,ebx "&
"xor ebx,ebx "&
"asmctDispclipLoop: "&
"mov ecx,ctclipbmp_xdim "&
"asmctDispclipLoop2: "&
"lodsb "&
"cmp al,0 "&
"je ctClipBlack "&
"mov eax,ctclip_color "&
"stosb "&
"jmp ctclip_no_add "&
"ctClipBlack: "&
"inc edi "&
"ctclip_no_add: "&
"loop asmctDispclipLoop2 "&
"inc ebx "&
"cmp ebx,edx "&
"je asmctDispclipDone "&
"add edi,ctdispclip_offs_add "&
"add esi,ctclipimg_offs_add "&
"jmp asmctDispclipLoop "&
"asmctDispclipDone: "&
"popa ret ")
constant asm_ctdispclip_x=asm_ctdispclip_code+get_param("asm_ctdispclip_x")
constant asm_ctdispclip_y=asm_ctdispclip_code+get_param("asm_ctdispclip_y")
constant ctdispclip_screen_addr=asm_ctdispclip_code+get_param("ctdispclip_screen_addr")
constant ctclipbmp_xdim=asm_ctdispclip_code+get_param("ctclipbmp_xdim")
constant ctclipbmp_ydim=asm_ctdispclip_code+get_param("ctclipbmp_ydim")
constant ctdispclip_offs_add=asm_ctdispclip_code+get_param("ctdispclip_offs_add")
constant ctclip_color=asm_ctdispclip_code+get_param("ctclip_color")
constant ctclipbmp_img_addr=asm_ctdispclip_code+get_param("ctclipbmp_img_addr")
constant ctclipimg_offs_add=asm_ctdispclip_code+get_param("ctclipimg_offs_add")

global procedure asm_ctdisplay_clip(sequence coords,sequence tha_img,integer ctColor,
atom tha_screen_addr)
integer bmpXdim,bmpYdim,xEnd,yEnd
integer clippedXdim,clippedYdim
integer clipX,clipY,xLen,yLen
integer startOffsAdd,clipOffsAdd,noDisp
bmpXdim=(tha_img[2])
bmpYdim=(tha_img[3])
xLen=bmpXdim
yLen=bmpYdim
startOffsAdd=0
clipOffsAdd=0
clipX=coords[1]
clipY=coords[2]
xEnd=(coords[1]+bmpXdim-1)
yEnd=(coords[2]+bmpYdim-1)
noDisp=0
if coords[1]<clip_box_coords[1][1] then
if xEnd<clip_box_coords[1][1] then
noDisp=1
end if
clipX=clip_box_coords[1][1]
startOffsAdd=clipX-coords[1]
clipOffsAdd=startOffsAdd
xLen=xLen-startOffsAdd
end if
if coords[2]<clip_box_coords[1][2] then
if yEnd<clip_box_coords[1][2] then
noDisp=1
end if
clipY=clip_box_coords[1][2]
startOffsAdd=startOffsAdd+((clipY-coords[2])*bmpXdim)
yLen=yLen-(clipY-coords[2])
end if
if (coords[1]>clip_box_coords[2][1]) or (coords[2]>clip_box_coords[2][2]) then
noDisp=1
end if
if xEnd>clip_box_coords[2][1] then
xLen=xLen-(xEnd-clip_box_coords[2][1])
clipOffsAdd=clipOffsAdd+(xEnd-clip_box_coords[2][1])
end if
if yEnd>clip_box_coords[2][2] then
yLen=yLen-(yEnd-clip_box_coords[2][2])
end if
if noDisp=0 then
poke4(asm_ctdispclip_x,clipX)
poke(asm_ctdispclip_y,clipY)
poke4(ctclipbmp_xdim,xLen)
poke(ctclipbmp_ydim,yLen)
poke4(ctdispclip_offs_add,(320-xLen))
poke(ctclip_color,ctColor)
poke4(ctdispclip_screen_addr,tha_screen_addr)
poke4(ctclipbmp_img_addr,tha_img[1]+startOffsAdd)
poke4(ctclipimg_offs_add,clipOffsAdd)
call(asm_ctdispclip_code)
end if
end procedure

constant asm_cls_code=get_asm(
"pusha cld "&
"mov ebx,cls_screen_addr "&
"mov edi,ebx "&
"mov eax,asm_cls_color "&
"mov ecx,16000 "&
"rep stosd "&
"popa ret ")
constant cls_screen_addr=asm_cls_code+get_param("cls_screen_addr")
constant asm_cls_color=asm_cls_code+get_param("asm_cls_color")

global procedure asm_cls(atom tha_scr,integer tha_col)
tha_col=(tha_col*16777216)+(tha_col*65536)+(tha_col*256)+tha_col
poke4(cls_screen_addr,tha_scr)
poke4(asm_cls_color,tha_col)
call(asm_cls_code)
end procedure



constant copy_screen_code=get_asm(
"pusha cld "&
"mov ebx,copy_dest_addr "&
"mov edi,ebx "&
"mov ebx,copy_src_addr "&
"mov esi,ebx "&
"mov ecx,16000 "&
"rep movsd "&
"popa ret ")
constant copy_dest_addr=copy_screen_code+get_param("copy_dest_addr")
constant copy_src_addr=copy_screen_code+get_param("copy_src_addr")

global procedure asm_copy_screen(atom src,atom dest)
poke4(copy_dest_addr,dest)
poke4(copy_src_addr,src)
call(copy_screen_code)
end procedure

global procedure mem_cls(atom tha_screen_addr,integer tha_col)
mem_set(tha_screen_addr,tha_col,64000)
end procedure

global procedure mem_cls_clip(atom tha_screen_addr,integer tha_col)
integer cb_len
cb_len=(clip_box_coords[2][1]-clip_box_coords[1][1])+1
for i=clip_box_coords[1][2] to clip_box_coords[2][2] do
mem_set(tha_screen_addr+(i*320)+clip_box_coords[1][1],tha_col,cb_len)
end for
end procedure


global function poke_bitmap(sequence tha_bgf_img)
sequence ret_seq
atom tha_mem_space
tha_mem_space=allocate((length(tha_bgf_img)*length(tha_bgf_img[1])))
ret_seq=repeat(0,3)
for i=1 to length(tha_bgf_img) do
poke(tha_mem_space+(length(tha_bgf_img[1])*(i-1)),tha_bgf_img[i])
end for
ret_seq[1]=tha_mem_space
ret_seq[2]=length(tha_bgf_img[1])
ret_seq[3]=length(tha_bgf_img)
return ret_seq
end function


global function set_col(sequence tha_pal2,integer tha_col_num,sequence tha_pal)
Output(tha_col_num,#3C8)
Output(tha_pal[1],#3C9)
Output(tha_pal[2],#3C9)
Output(tha_pal[3],#3C9)
tha_pal2[tha_col_num+1]=tha_pal
return tha_pal2
end function


global procedure set_pal(sequence tha_pal)
for i=1 to 256 do
Output(i-1,#3C8)
Output(tha_pal[i][1],#3C9)
Output(tha_pal[i][2],#3C9)
Output(tha_pal[i][3],#3C9)
end for
end procedure


global procedure free_asm_code()
free(asm_disp_code)
free(asm_w_disp_code)
free(asm_d_disp_code)
free(asm_cdisp_code)
free(asm_tdisp_code)
free(asm_ctdisp_code)
free(asm_dispclip_code)
free(asm_w_dispclip_code)
free(asm_d_dispclip_code)
free(asm_cdispclip_code)
free(asm_tdispclip_code)
free(asm_ctdispclip_code)
free(asm_scale_disp_code)
free(asm_scale_tdisp_code)
free(asm_scale_disp_clip_code)
free(asm_scale_tdisp_clip_code)
free(copy_screen_code)
free(asm_cls_code)
free(wait_vrt_code)
free(short_wait_vrt_code)
end procedure



global procedure short_delay(integer delays)
poke(1132,0)
while peek(1132)<delays do
end while
end procedure


global function fade_to_rgb(sequence tha_pal_array,sequence to_rgb,integer tha_delay)
integer done_fading
done_fading=0
while done_fading=0 do
done_fading=1
for i=1 to 256 do
 for j=1 to 3 do
  if tha_pal_array[i][j]>to_rgb[j] then
   tha_pal_array[i][j]=tha_pal_array[i][j]-1
   done_fading=0
   end if
  if tha_pal_array[i][j]<to_rgb[j] then
   tha_pal_array[i][j]=tha_pal_array[i][j]+1
   done_fading=0
  end if
 end for
if tha_delay!=no_fading then
Output(i-1,#3C8)
Output(tha_pal_array[i][1],#3C9)
Output(tha_pal_array[i][2],#3C9)
Output(tha_pal_array[i][3],#3C9)
end if
end for
if (tha_delay!=no_fading) and (tha_delay!=no_delay) then
--short_delay(tha_delay)
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end while
return tha_pal_array
end function

global function fade_towards_rgb(sequence tha_pal_array,sequence to_rgb,integer fade_steps,integer tha_delay)
for k=1 to fade_steps do
for i=1 to 256 do
 for j=1 to 3 do
  if tha_pal_array[i][j]>to_rgb[j] then
   tha_pal_array[i][j]=tha_pal_array[i][j]-1
  end if
  if tha_pal_array[i][j]<to_rgb[j] then
   tha_pal_array[i][j]=tha_pal_array[i][j]+1
  end if
 end for
if tha_delay!=no_fading then
Output(i-1,#3C8)
Output(tha_pal_array[i][1],#3C9)
Output(tha_pal_array[i][2],#3C9)
Output(tha_pal_array[i][3],#3C9)
end if
end for
if (tha_delay!=no_fading) and (tha_delay!=no_delay) then
--short_delay(tha_delay)
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end for
return tha_pal_array
end function

global function fade_sprite_towards_rgb(sequence tha_pal_array,sequence spt_pal,sequence to_rgb,integer fade_steps,integer tha_delay)
for k=1 to fade_steps do
 for i=1 to length(spt_pal) do
  for j=1 to 3 do
   if tha_pal_array[spt_pal[i]+1][j]>to_rgb[j] then
    tha_pal_array[spt_pal[i]+1][j]=tha_pal_array[spt_pal[i]+1][j]-1
   end if
   if tha_pal_array[spt_pal[i]+1][j]<to_rgb[j] then
    tha_pal_array[spt_pal[i]+1][j]=tha_pal_array[spt_pal[i]+1][j]+1
   end if
  end for
  if tha_delay!=no_fading then
  Output(spt_pal[i],#3C8)
  Output(tha_pal_array[spt_pal[i]+1][1],#3C9)
  Output(tha_pal_array[spt_pal[i]+1][2],#3C9)
  Output(tha_pal_array[spt_pal[i]+1][3],#3C9)
  end if
 end for
 if (tha_delay!=no_fading) and (tha_delay!=no_delay) then
 --short_delay(tha_delay)
 for nnn=1 to tha_delay do
 wait_vrt()
 end for
 end if
end for
return tha_pal_array
end function
 
global function fade_to_pal(sequence tha_pal_array,sequence tha_goal_array,integer tha_delay)
integer done_fading
done_fading=0
while done_fading=0 do
done_fading=1
for i=1 to 256 do
 for j=1 to 3 do
  if tha_pal_array[i][j]>tha_goal_array[i][j] then
   tha_pal_array[i][j]=tha_pal_array[i][j]-1
   done_fading=0
   end if
  if tha_pal_array[i][j]<tha_goal_array[i][j] then
   tha_pal_array[i][j]=tha_pal_array[i][j]+1
   done_fading=0
  end if
 end for
if tha_delay!=no_fading then
Output(i-1,#3C8)
Output(tha_pal_array[i][1],#3C9)
Output(tha_pal_array[i][2],#3C9)
Output(tha_pal_array[i][3],#3C9)
end if
end for
if (tha_delay!=no_fading) and (tha_delay!=no_delay) then
--short_delay(tha_delay)
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end while
return tha_pal_array
end function


global function fade_tone_to(sequence tha_pal_array,integer tha_tone_goal,integer tha_tone_num,integer tha_delay)
integer done_fading
done_fading=0
while done_fading=0 do
done_fading=1
for i=1 to 256 do
  if tha_pal_array[i][tha_tone_num]>tha_tone_goal then
  tha_pal_array[i][tha_tone_num]=tha_pal_array[i][tha_tone_num]-1
  done_fading=0
  end if
  if tha_pal_array[i][tha_tone_num]<tha_tone_goal then
   tha_pal_array[i][tha_tone_num]=tha_pal_array[i][tha_tone_num]+1
   done_fading=0
  end if

if tha_delay!=no_fading then
Output(i-1,#3C8)
Output(tha_pal_array[i][1],#3C9)
Output(tha_pal_array[i][2],#3C9)
Output(tha_pal_array[i][3],#3C9)
end if
end for
if (tha_delay!=no_fading) and (tha_delay!=no_delay) then
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end while
return tha_pal_array
end function


global function fade_sprite_tone_to(sequence tha_pal_array,sequence sPal,integer tha_tone_goal,integer tha_tone_num,integer tha_delay)
integer done_fading
done_fading=0
while done_fading=0 do
done_fading=1
for i=1 to length(sPal) do
  if tha_pal_array[sPal[i]+1][tha_tone_num]>tha_tone_goal then
  if tha_pal_array[sPal[i]+1][tha_tone_num]>0 then
  tha_pal_array[sPal[i]+1][tha_tone_num]=tha_pal_array[sPal[i]+1][tha_tone_num]-1
  done_fading=0
  end if
  end if
  if tha_pal_array[sPal[i]+1][tha_tone_num]<tha_tone_goal then
   if tha_pal_array[sPal[i]+1][tha_tone_num]<63 then
   tha_pal_array[sPal[i]+1][tha_tone_num]=tha_pal_array[sPal[i]+1][tha_tone_num]+1
   done_fading=0
  end if
  end if
if tha_delay!=no_fading then
Output(sPal[i],#3C8)
Output(tha_pal_array[sPal[i]+1][1],#3C9)
Output(tha_pal_array[sPal[i]+1][2],#3C9)
Output(tha_pal_array[sPal[i]+1][3],#3C9)
end if
end for
if (tha_delay!=no_fading) and (tha_delay!=no_delay) then
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end while
return tha_pal_array
end function



global function get_sprite_colors(sequence tha_sprite)
sequence ret_seq,cmp_seq
integer col_found
ret_seq={}
cmp_seq={0}
for i=1 to length(tha_sprite) do
 for j=1 to length(tha_sprite[1]) do
  col_found=0
  for k=1 to length(cmp_seq) do
   if tha_sprite[i][j]=cmp_seq[k] then
    col_found=1
   end if
  end for 
  if col_found=0 then
   ret_seq=ret_seq&tha_sprite[i][j]
   cmp_seq=cmp_seq&tha_sprite[i][j]
  end if
 end for
end for
return ret_seq
end function

global function remap_colors(sequence tha_img,sequence tha_pal,integer start_col)
sequence ret_seq,spt_clrs,tmp_pal,sc
sequence colors_found,col_tbl,cmp_seq
integer sptz,chgd,ll,base_col,col_found
sptz=length(tha_img)
sc=repeat(start_col,sptz)
tmp_pal=repeat({666,0,0},256)
spt_clrs=repeat(0,sptz)

base_col=start_col
for i=1 to sptz do
 col_tbl=repeat(0,256)
 colors_found={0}
 cmp_seq=colors_found
 for j=1 to length(tha_img[i]) do
  for k=1 to length(tha_img[i][1]) do
   col_found=0
   for l=1 to length(cmp_seq) do
    if tha_img[i][j][k]=colors_found[l] then
    col_found=1
   end if
   end for
    if col_found=0 then
    colors_found=colors_found&tha_img[i][j][k]
    col_tbl[tha_img[i][j][k]+1]=base_col
    base_col=base_col+1
   end if
   cmp_seq=colors_found
   ll=1
   chgd=0
   while (ll<=length(colors_found)) and (chgd=0) do
   --for l=1 to length(colors_found) do
    if (tha_img[i][j][k]=colors_found[ll]) and (colors_found[ll]!=0) then
     tmp_pal[col_tbl[tha_img[i][j][k]+1]+1]=tha_pal[tha_img[i][j][k]+1]
     tha_img[i][j][k]=col_tbl[tha_img[i][j][k]+1]
    chgd=1
    end if
   --end for
   ll=ll+1
   end while
  end for
 end for
end for

for i=1 to 256 do
 if tmp_pal[i][1]!=666 then
  tha_pal[i]=tmp_pal[i]
 end if
end for
ret_seq={tha_pal,tha_img}
return ret_seq
end function

global function swap_tone(sequence aPal,integer tn1,integer tn2,integer tha_delay)
sequence tmppal
integer tmpp,done_fading
tmppal=aPal
done_fading=0
while done_fading=0 do
done_fading=1
for i=0 to 255 do
if aPal[i+1][tn1]<tmppal[i+1][tn2] then
if aPal[i+1][tn1]<63 then
done_fading=0
aPal[i+1][tn1]=aPal[i+1][tn1]+1
end if
end if
if aPal[i+1][tn1]>tmppal[i+1][tn2] then
if aPal[i+1][tn1]>0 then
done_fading=0
aPal[i+1][tn1]=aPal[i+1][tn1]-1
end if
end if
if aPal[i+1][tn2]<tmppal[i+1][tn1] then
if aPal[i+1][tn2]<63 then
done_fading=0
aPal[i+1][tn2]=aPal[i+1][tn2]+1
end if
end if
if aPal[i+1][tn2]>tmppal[i+1][tn1] then
if aPal[i+1][tn2]>0 then
done_fading=0
aPal[i+1][tn2]=aPal[i+1][tn2]-1
end if
end if
if tha_delay!=no_fading then
Output(i,#3C8)
Output(aPal[i+1][1],#3C9)
Output(aPal[i+1][2],#3C9)
Output(aPal[i+1][3],#3C9)
end if
end for
if tha_delay!=no_delay and (tha_delay!=no_fading) then
--short_delay(tha_delay)
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end while
return aPal
end function



global function sprite_swap_tone(sequence aPal,sequence sPal,integer tn1,integer tn2,integer tha_delay)
sequence tmppal
integer tmpp,done_fading
tmppal=aPal
done_fading=0
while done_fading=0 do
done_fading=1
for i=1 to length(sPal) do

if aPal[sPal[i]+1][tn1]<tmppal[sPal[i]+1][tn2] then
if aPal[sPal[i]+1][tn1]<63 then
done_fading=0
aPal[sPal[i]+1][tn1]=aPal[sPal[i]+1][tn1]+1
end if
end if
if aPal[sPal[i]+1][tn1]>tmppal[sPal[i]+1][tn2] then
if aPal[sPal[i]+1][tn1]>0 then
done_fading=0
aPal[sPal[i]+1][tn1]=aPal[sPal[i]+1][tn1]-1
end if
end if
if aPal[sPal[i]+1][tn2]<tmppal[sPal[i]+1][tn1] then
if aPal[sPal[i]+1][tn2]<63 then
done_fading=0
aPal[sPal[i]+1][tn2]=aPal[sPal[i]+1][tn2]+1
end if
end if
if aPal[sPal[i]+1][tn2]>tmppal[sPal[i]+1][tn1] then
if aPal[sPal[i]+1][tn2]>0 then
done_fading=0
aPal[sPal[i]+1][tn2]=aPal[sPal[i]+1][tn2]-1
end if
end if

--tmpp=aPal[sPal[i]+1][tn1]
--aPal[sPal[i]+1][tn1]=aPal[sPal[i]+1][tn2]
--aPal[sPal[i]+1][tn2]=tmpp
if tha_delay!=no_fading then
Output(sPal[i],#3C8)
Output(aPal[sPal[i]+1][1],#3C9)
Output(aPal[sPal[i]+1][2],#3C9)
Output(aPal[sPal[i]+1][3],#3C9)
end if
end for
if (tha_delay!=no_delay) and (tha_delay!=no_fading) then
--short_delay(tha_delay)
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end while
return aPal
end function

global function rgb_add(sequence aPal,sequence rgbAdd,integer tha_delay)
sequence tmpp
integer done_fading
tmpp=aPal
done_fading=0
while done_fading=0 do
done_fading=1
for i=0 to 255 do
for j=1 to 3 do
if aPal[i+1][j]<(tmpp[i+1][j]+rgbAdd[j]) then
if aPal[i+1][j]<63 then
aPal[i+1][j]=aPal[i+1][j]+1
done_fading=0
end if
end if
if aPal[i+1][j]>(tmpp[i+1][j]+rgbAdd[j]) then
if aPal[i+1][j]>0 then
aPal[i+1][j]=aPal[i+1][j]-1
done_fading=0
end if
end if
end for
if tha_delay!=no_fading then
Output(i,#3C8)
Output(aPal[i+1][1],#3C9)
Output(aPal[i+1][2],#3C9)
Output(aPal[i+1][3],#3C9)
end if
end for
if (tha_delay!=no_delay) and (tha_delay!=no_fading) then
--short_delay(tha_delay)
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end while
return aPal
end function


global function sprite_rgb_add(sequence aPal,sequence sPal,sequence rgbAdd,integer tha_delay)
sequence tmpp
integer done_fading
tmpp=aPal
done_fading=0
while done_fading=0 do
done_fading=1
for i=1 to length(sPal) do
for j=1 to 3 do
if aPal[sPal[i]+1][j]<(tmpp[sPal[i]+1][j]+rgbAdd[j]) then
if aPal[sPal[i]+1][j]<63 then
aPal[sPal[i]+1][j]=aPal[sPal[i]+1][j]+1
done_fading=0
end if
end if
if aPal[sPal[i]+1][j]>(tmpp[sPal[i]+1][j]+rgbAdd[j]) then
if aPal[sPal[i]+1][j]>0 then
aPal[sPal[i]+1][j]=aPal[sPal[i]+1][j]-1
done_fading=0
end if
end if
end for
if tha_delay!=no_fading then
Output(sPal[i],#3C8)
Output(aPal[sPal[i]+1][1],#3C9)
Output(aPal[sPal[i]+1][2],#3C9)
Output(aPal[sPal[i]+1][3],#3C9)
end if
end for
if (tha_delay!=no_delay) and (tha_delay!=no_fading) then
--short_delay(tha_delay)
for nnn=1 to tha_delay do
wait_vrt()
end for
end if
end while
return aPal
end function



global function fade_tone_towards(sequence aPal,integer tone_goal,integer tone_num,integer tone_steps,integer tha_delay)
for i=1 to tone_steps do
for j=0 to 255 do
if aPal[j+1][tone_num]<tone_goal then
if aPal[j+1][tone_num]<63 then
aPal[j+1][tone_num]=aPal[j+1][tone_num]+1
end if
end if
if aPal[j+1][tone_num]>tone_goal then
if aPal[j+1][tone_num]>0 then
aPal[j+1][tone_num]=aPal[j+1][tone_num]-1
end if
end if
if tha_delay!=no_fading then
Output(i,#3C8)
Output(aPal[j+1][1],#3C9)
Output(aPal[j+1][2],#3C9)
Output(aPal[j+1][3],#3C9)
end if
end for
if (tha_delay!=no_delay) and (tha_delay!=no_fading) then
short_delay(tha_delay)
end if
end for
return aPal
end function

global function fade_sprite_tone_towards(sequence aPal,sequence sPal,integer tone_goal,integer tone_num,integer tone_steps,integer tha_delay)
for i=1 to tone_steps do
for j=1 to length(sPal) do
if aPal[sPal[j]+1][tone_num]<tone_goal then
if aPal[sPal[j]+1][tone_num]<63 then
aPal[sPal[j]+1][tone_num]=aPal[sPal[j]+1][tone_num]+1
end if
end if
if aPal[sPal[j]+1][tone_num]>tone_goal then
if aPal[sPal[j]+1][tone_num]>0 then
aPal[sPal[j]+1][tone_num]=aPal[sPal[j]+1][tone_num]-1
end if
end if
if tha_delay!=no_fading then
Output(i,#3C8)
Output(aPal[sPal[j]+1][1],#3C9)
Output(aPal[sPal[j]+1][2],#3C9)
Output(aPal[sPal[j]+1][3],#3C9)
end if
end for
if (tha_delay!=no_delay) and (tha_delay!=no_fading) then
short_delay(tha_delay)
end if
end for
return aPal
end function

function find_rgb(sequence tha_pal,sequence tha_rgb)
integer tmp,retVal,diffr
retVal=-1
diffr=63
for i=1 to 256 do
tmp=0
for j=1 to 3 do
tmp=tmp+diff(tha_pal[i][j],tha_rgb[j])
end for
tmp=floor(tmp/3)
if tmp<diffr then
retVal=(i-1)
diffr=tmp
end if
end for
return retVal
end function

